pcl::DigitalElevationMapBuilder Class Reference

Build a Digital Elevation Map in the column-disparity space from a disparity map and a color image of the scene. More...

`#include <pcl/stereo/digital_elevation_map.h>`

Inheritance diagram for pcl::DigitalElevationMapBuilder:

## Public Member Functions

| DigitalElevationMapBuilder ()
| DigitalElevationMapBuilder constructor. More...
virtual | ~DigitalElevationMapBuilder ()
| Empty destructor. More...
void | setResolution (size_t resolution_column, size_t resolution_disparity)
| Set resolution of the DEM. More...
size_t | getColumnResolution () const
| Get column resolution of the DEM. More...
size_t | getDisparityResolution () const
| Get disparity resolution of the DEM. More...
void | setMinPointsInCell (size_t min_points_in_cell)
| Set minimum amount of points in a DEM's cell. More...
size_t | getMinPointsInCell () const
| Get minimum amount of points in a DEM's cell. More...
void | compute (pcl::PointCloud< PointDEM > &out_cloud)
| Compute the Digital Elevation Map. More...
Public Member Functions inherited from pcl::DisparityMapConverter< PointDEM >
| DisparityMapConverter ()
| DisparityMapConverter constructor. More...
virtual | ~DisparityMapConverter ()
| Empty destructor. More...
void | setImageCenterX (const float center_x)
| Set x-coordinate of the image center. More...
float | getImageCenterX () const
| Get x-coordinate of the image center. More...
void | setImageCenterY (const float center_y)
| Set y-coordinate of the image center. More...
float | getImageCenterY () const
| Get y-coordinate of the image center. More...
void | setFocalLength (const float focal_length)
| Set focal length. More...
float | getFocalLength () const
| Get focal length. More...
void | setBaseline (const float baseline)
| Set baseline. More...
float | getBaseline () const
| Get baseline. More...
void | setDisparityThresholdMin (const float disparity_threshold_min)
| Set min disparity threshold. More...
float | getDisparityThresholdMin () const
| Get min disparity threshold. More...
void | setDisparityThresholdMax (const float disparity_threshold_max)
| Set max disparity threshold. More...
float | getDisparityThresholdMax () const
| Get max disparity threshold. More...
void | setImage (const pcl::PointCloud< pcl::RGB >::ConstPtr &image)
| Set an image, that will be used for coloring of the output cloud. More...
pcl::PointCloud< RGB >::Ptr | getImage ()
| Get the image, that is used for coloring of the output cloud. More...
bool | loadDisparityMap (const std::string &file_name)
| Load the disparity map. More...
bool | loadDisparityMap (const std::string &file_name, const size_t width, const size_t height)
| Load the disparity map and initialize it's size. More...
void | setDisparityMap (const std::vector< float > &disparity_map)
| Set the disparity map. More...
void | setDisparityMap (const std::vector< float > &disparity_map, const size_t width, const size_t height)
| Set the disparity map and initialize it's size. More...
std::vector< float > | getDisparityMap ()
| Get the disparity map. More...
virtual void | compute (PointCloud &out_cloud)
| Compute the output cloud. More...

## Protected Attributes

size_t | resolution_column_
| Column resolution of the DEM. More...
size_t | resolution_disparity_
| disparity resolution of the DEM. More...
size_t | min_points_in_cell_
| Minimum amount of points in a DEM's cell. More...
Protected Attributes inherited from pcl::DisparityMapConverter< PointDEM >
float | center_x_
| X-coordinate of the image center. More...
float | center_y_
| Y-coordinate of the image center. More...
float | focal_length_
| Focal length. More...
float | baseline_
| Baseline. More...
bool | is_color_
| Is color image is set. More...
pcl::PointCloud< pcl::RGB >::ConstPtr | image_
| Color image of the scene. More...
std::vector< float > | disparity_map_
| Vector for the disparity map. More...
size_t | disparity_map_width_
| X-size of the disparity map. More...
size_t | disparity_map_height_
| Y-size of the disparity map. More...
float | disparity_threshold_min_
| Thresholds of the disparity. More...
float | disparity_threshold_max_

## Additional Inherited Members

Protected Types inherited from pcl::DisparityMapConverter< PointDEM >
typedef pcl::PointCloud< PointDEM > | PointCloud
Protected Member Functions inherited from pcl::DisparityMapConverter< PointDEM >
PointXYZ | translateCoordinates (size_t row, size_t column, float disparity) const
| Translate point from image coordinates and disparity to 3D-coordinates. More...

## Detailed Description

Build a Digital Elevation Map in the column-disparity space from a disparity map and a color image of the scene.

Example of usage:

pcl::PointCloud<pcl::PointDEM>::Ptr cloud (new
pcl::PointCloud<pcl::PointDEM>);
pcl::PointCloud<pcl::RGB>::Ptr left_image (new
pcl::PointCloud<pcl::RGB>);
// Fill left image cloud.
pcl::DigitalElevationMapBuilder demb;
demb.setBaseline (0.8387445f);
demb.setFocalLength (368.534700f);
demb.setImageCenterX (318.112200f);
demb.setImageCenterY (224.334900f);
demb.setDisparityThresholdMin (15.0f);
demb.setDisparityThresholdMax (80.0f);
demb.setResolution (64, 32);
// Left view of the scene.
demb.loadImage (left_image);
// Disparity map of the scene.
demb.loadDisparityMap ("disparity_map.txt", 640, 480);
demb.compute(*cloud);

Author
  Timur Ibadov (ibado.nosp@m.v.ti.nosp@m.mur@g.nosp@m.mail.nosp@m..com)

Definition at line 75 of file digital_elevation_map.h.

## Constructor & Destructor Documentation

## DigitalElevationMapBuilder()

pcl::DigitalElevationMapBuilder::DigitalElevationMapBuilder | ( |  | ) |

DigitalElevationMapBuilder constructor.

## ~DigitalElevationMapBuilder()

virtual pcl::DigitalElevationMapBuilder::~DigitalElevationMapBuilder | ( |  | ) |

virtual

Empty destructor.

## Member Function Documentation

## compute()

void pcl::DigitalElevationMapBuilder::compute | ( | pcl::PointCloud< PointDEM > & | out_cloud | ) |

Compute the Digital Elevation Map.

Parameters

  [out] | out_cloud | the variable to return the resulting cloud.

## getColumnResolution()

size_t pcl::DigitalElevationMapBuilder::getColumnResolution | ( |  | ) | const

Get column resolution of the DEM.

Returns
  column resolution of the DEM.

## getDisparityResolution()

size_t pcl::DigitalElevationMapBuilder::getDisparityResolution | ( |  | ) | const

Get disparity resolution of the DEM.

Returns
  disparity resolution of the DEM.

## getMinPointsInCell()

size_t pcl::DigitalElevationMapBuilder::getMinPointsInCell | ( |  | ) | const

Get minimum amount of points in a DEM's cell.

Returns
  minimum amount of points in a DEM's cell.

## setMinPointsInCell()

void pcl::DigitalElevationMapBuilder::setMinPointsInCell | ( | size_t | min_points_in_cell | ) |

Set minimum amount of points in a DEM's cell.

Parameters

  [in] | min_points_in_cell | minimum amount of points in a DEM's cell.

## setResolution()

void pcl::DigitalElevationMapBuilder::setResolution | ( | size_t | resolution_column,
|  | size_t | resolution_disparity
| ) |  |

Set resolution of the DEM.

Parameters

  [in] | resolution_column | the column resolution.
  [in] | resolution_disparity | the disparity resolution.

## Member Data Documentation

## min_points_in_cell_

size_t pcl::DigitalElevationMapBuilder::min_points_in_cell_

protected

Minimum amount of points in a DEM's cell.

Definition at line 136 of file digital_elevation_map.h.

## resolution_column_

size_t pcl::DigitalElevationMapBuilder::resolution_column_

protected

Column resolution of the DEM.

Definition at line 131 of file digital_elevation_map.h.

## resolution_disparity_

size_t pcl::DigitalElevationMapBuilder::resolution_disparity_

protected

disparity resolution of the DEM.

Definition at line 133 of file digital_elevation_map.h.

The documentation for this class was generated from the following file:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/stereo/include/pcl/stereo/digital_elevation_map.h